# number of elements
n = 5


l = 3/n;

E = 1;
A = 1;

# mkp solution
ki = (E*A/l)*[1 -1; -1 1];
fi = [l^2/(2*l) l^2/(2*l)];
K = zeros (n+1);
F = zeros (n+1, 1);
for i=1:n
    loc = [i i+1];
    K(loc, loc) += ki;
    F(loc)+= fi';
endfor
u = K(2:n+1, 2:n+1)\(F(2:n+1,1));
U = [0 ; u]

# plot analytical solution
hold on;
x = 0:0.1:3;
plot (x, -x.^2/2+3*x, "b;u;", x, -x+3, "r;N;")

sig = zeros(n,1);
# evaluate stress and plot obtained solution
for i=1:n
    eps = (U(i+1)-U(i))/l;
    sig(i) = E*eps;
    N = A*E*eps;
    plot ([(i-1)*l i*l], [U(i) U(i+1)], "b--")
    plot ([(i-1)*l i*l], [N N], "r--")
endfor

