# evaluate recovered stresses
Ai = [l/2, 0; 0, l/2];
bi = [l/2;l/2];
A = zeros(n+1);
B = zeros(n+1,1);
for i=1:n
    loc = [i i+1];
    A(loc, loc) += Ai;
    B(loc)+= sig(i)*bi;
endfor
sig2 = A\B;

# plot analytical solution
hold on;
x = 0:0.1:3;
plot (x, -x+3, "r;Sigma;")

# plot recovered stresses
hold on;
for i=1:n
    plot ([(i-1)*l i*l], [sig(i) sig(i)], "r--")
    plot ([(i-1)*l i*l], [sig2(i) sig2(i+1)], "o--")
endfor
