# numerical integration
w = [0.26014666666; 0.26014666666;0.26014666666; -0.28125];
xi=[0.2, 0.2; 0.6, 0.2; 0.2, 0.6; 0.3333333333, 0.3333333333];

# contribution to the error from elements
e = zeros(nelem,1);
err = 0.0;
sig
for en=1:nelem
    sig2e = [sig2(enodes(en,1),:); sig2(enodes(en,2),:);sig2(enodes(en,3),:)];
    xe = [x(enodes(en,:))] ;
    ye = [y(enodes(en,:))] ;
    Ae=(1/2)*((xe(2)*ye(3)-xe(3)*ye(2))-(xe(1)*ye(3)-xe(3)*ye(1))+(xe(1)*ye(2)-xe(2)*ye(1))) ;
    [ke,dbe,de,be] = plane_stress(xe,ye,E,nu) ; # de

    for ip=1:4
        xiip = [xi(ip,1), xi(ip,2), 1-xi(ip,1)-xi(ip,2)];
        sig2xi = xiip*sig2e;# stress at integration point
        dsig = sig2xi-sig(en,:); #difference sigma_*-sigma_mkp
        e(en) += (dsig)*inv(de)*dsig'*w(ip)*Ae*2;

    endfor
    err = err+e(en);
endfor
e
err
