# evaluate recovered stresses

A = zeros(nnodes);
B = zeros(nnodes,3);
for en=1:nelem
    xe = [x(enodes(en,:))] ;
    ye = [y(enodes(en,:))] ;
    [Ai,bi] = plane_stress_reco (xe,ye,sig(en,:));
    lm = [enodes(en,1), enodes(en,2), enodes(en,3)]; #code numbers = node numbers
    A(lm, lm) += Ai;
    B(lm,[1,2,3])+= bi;
endfor
sig2 = A\B

if (0)
    hold on;
    caxis ("auto")
    colorbar;
    for en=1:nelem
        xe = [x(enodes(en,:));  x(enodes(en,1))];
        ye = [y(enodes(en,:));  y(enodes(en,1))];
        sig2e = [sig2(enodes(en,:),1); sig2(enodes(en,1),1)];
        patch (xe, ye, sig2e);
    endfor
endif
